import static java.lang.Math.*;


public class springFunc{
    static vectorFunc v = new vectorFunc();;
    static atomFunc a = new atomFunc();;
    
    public static vector springForces(spring s, atom[] atomLst)    // return self repulsion spring+damper forces
    {
       boolean istate = a.getrest(atomLst[s.i]);                 // get resting state for both atoms
       boolean jstate = a.getrest(atomLst[s.j]);
       if (istate == false || jstate == false)                   // if one of them is active do the springness
       {
        float distCenters = (float)sqrt(a.distanceCentersSQ(atomLst[s.i], atomLst[s.j]));  // returns distance, 
        if (distCenters == 0)
        {
            distCenters = 0.1f;
        }
        
        float restlenght = a.sizes(atomLst[s.i], atomLst[s.j])*1.0f;
        vector link = v.sub(atomLst[s.i].pos, atomLst[s.j].pos);
        ///float mult = restlenght / distCenters;
        float mult =  (distCenters - restlenght)*-38000;
        float comp = (atomLst[s.i].mass*atomLst[s.j].mass)/(atomLst[s.i].mass+atomLst[s.j].mass);
        
        vector spring = v.scale(v.sub(v.scale(link, mult), link), comp); // dist=distance surface to surface. (how deep) K=5000
        vector damper = v.scale((v.sub(atomLst[s.j].vel, atomLst[s.i].vel)), comp*100);            // D=damping  (semi broken) 
        return v.add(spring, damper);
       }
       else return new vector();                             // if both atom rested, return nothing
    }
    
    //usage
    //springLst = s.insert(springLst, nuspring
    //return new updated spring list
    public static spring insert(spring springLst, spring nuspring)
    {
        nuspring.next = springLst;
        return nuspring;
    }
    
    //usage in world
    //atomLst = iterate(springLst, atomLst)
    //return new updated atom list
    public static atom[] iterateForce(spring sprCur, atom [] atomLst, int atomQty)
    {
        //create new list
        atom nuatomLst[] = new atom[atomQty];
        for (int i=0;i<atomQty;i++)
            nuatomLst[i] = atomLst[i];
        //here is the function
        vector tmpForce = springForces(sprCur, atomLst);
        nuatomLst[sprCur.i] = a.addforce(nuatomLst[sprCur.i], tmpForce);
        nuatomLst[sprCur.j] = a.subforce(nuatomLst[sprCur.j], tmpForce);
        //not sure what to do about breakage
        //but cant be done here
        //this is recursive loop... trolololo
        if (sprCur.next != null)
            return iterateForce(sprCur.next, nuatomLst, atomQty);
        //return the list
        return nuatomLst;
    }
    
    //usage
    //springLst = pete(springToPete)
    //list will be null if none left
    public static spring pete(spring sprCur)
    {
        // double linked list
        // a <=> b <=> c
        // remove b
        // a->next = b-> next :::: while a =  b->back, then b->back->next = b->next
        // something alike with c
        // a <=> c
        if (sprCur.next != null)
            sprCur.next.back = sprCur.back;
        if (sprCur.back != null)
        {
            sprCur.back.next = sprCur.next;
            while(sprCur.back != null)
                sprCur = sprCur.back;
            return sprCur;
        }
        return sprCur.next;
    }
    
    //simple iterator
    //usage
    //sprLoop = next(sprLoop);
    public static spring next(spring sprCur)
    {
        return sprCur.next;
    }
}
